diff -Naur nginx-0.5.14/src/http/modules/ngx_http_fastcgi_module.c nginx-0.5.14.gns/src/http/modules/ngx_http_fastcgi_module.c
--- nginx-0.5.14/src/http/modules/ngx_http_fastcgi_module.c	2007-03-18 13:13:33 +0200
+++ nginx-0.5.14.gns/src/http/modules/ngx_http_fastcgi_module.c	2007-04-12 17:03:25 +0300
@@ -19,6 +19,7 @@
     ngx_array_t                   *params_len;
     ngx_array_t                   *params;
     ngx_array_t                   *params_source;
+    ngx_array_t                   *catch_stderr;
 } ngx_http_fastcgi_loc_conf_t;
 
 
@@ -345,6 +346,13 @@
       offsetof(ngx_http_fastcgi_loc_conf_t, upstream.hide_headers),
       NULL },
 
+    { ngx_string("fastcgi_catch_stderr"),
+      NGX_HTTP_MAIN_CONF|NGX_HTTP_SRV_CONF|NGX_HTTP_LOC_CONF|NGX_CONF_FLAG,
+      ngx_conf_set_str_array_slot,
+      NGX_HTTP_LOC_CONF_OFFSET,
+      offsetof(ngx_http_fastcgi_loc_conf_t, catch_stderr),
+      NULL },
+
       ngx_null_command
 };
 
@@ -835,16 +843,18 @@
     u_char                         *start, *last;
     ngx_str_t                      *status_line, line;
     ngx_int_t                       rc, status;
-    ngx_uint_t                      i;
+    ngx_uint_t                      i,j;
     ngx_table_elt_t                *h;
     ngx_http_upstream_t            *u;
     ngx_http_fastcgi_ctx_t         *f;
     ngx_http_upstream_header_t     *hh;
     ngx_http_upstream_main_conf_t  *umcf;
+    ngx_http_fastcgi_loc_conf_t    *flcf;
 
     f = ngx_http_get_module_ctx(r, ngx_http_fastcgi_module);
 
     umcf = ngx_http_get_module_main_conf(r, ngx_http_upstream_module);
+    flcf = ngx_http_get_module_loc_conf(r, ngx_http_fastcgi_module);
 
     if (f == NULL) {
         f = ngx_pcalloc(r->pool, sizeof(ngx_http_fastcgi_ctx_t));
@@ -948,6 +958,13 @@
                 ngx_log_error(NGX_LOG_ERR, r->connection->log, 0,
                               "FastCGI sent in stderr: \"%V\"", &line);
 
+		ngx_str_t* catch_them  = flcf->catch_stderr->elts;
+		for (j = 0; j < flcf->catch_stderr->nelts; j++) {
+			if (ngx_strstr(line.data,catch_them[j].data)) {
+				return NGX_HTTP_INTERNAL_SERVER_ERROR;
+			}
+		}
+
                 if (u->buffer.pos == u->buffer.last) {
 
                     if (!f->fastcgi_stdout) {